/****************************************************************/
/*                                                           	*/
/*                       detour.h			        */
/*                                                            	*/
/****************************************************************/

//////////////////////////////// DIMENSIONS /////////////////////////////////


//# define perc		0
//# define senmot	1
//# define motor	2

class World : NslModule
{
public:
	NslDinFloat0 xw;	
	NslDinFloat0 yw; 
	NslDinFloat0 zw;	
	NslDinFloat0 wangle;
	NslDinFloat0 xf;
	NslDinFloat0 yf; 
	NslDinFloat0 zf;
	NslDoutFloat2 worldXZ;   	
	NslDoutFloat0 yb;
	NslDoutFloat0 zb;	
	NslDoutFloat0 xb_init;	
	NslDoutFloat0 xb_end; 

	//CambiosPredador
    NslDinFloat0 xp;	
	NslDinFloat0 yp; 
	NslDinFloat0 zp;	
	//FinCambiosPredador

	NslDoutFloat0 date;	
	NslDoutFloat0 dayhour;	

	NslDinFloat0 prey_ate;
	NslDoutFloat0 prey_alive;	

private:
	NslFloat2 worldXY;
	nsl_input_3d in;

	int cont;
	
public:
	World(char*,NslModule*,int,int,int);
	~World() {}
	
	void initSys();
	void simRun();
};

class Prey : NslModule
{
public:
	NslDoutFloat0 xw;
	NslDoutFloat0 yw; 	
	NslDoutFloat0 zw; 	
	NslDinFloat0 prey_alive;
	NslDoutFloat0 multiprey;
private:
	NslFloat0 boundary; 
	//NslFloat0 multiprey; 
	NslFloat0 worm_speed;		

public:
	Prey(char*,NslModule*);
	~Prey() {}
	
	void simRun();
};

//CambiosPredador
class Predator : NslModule
{
public:
	NslDoutFloat0 xp;
	NslDoutFloat0 yp; 	
	NslDoutFloat0 zp; 	
	
private:
	NslFloat0 boundary; 
	NslFloat0 predator_speed;		

public:
	Predator(char*,NslModule*);
	~Predator() {}
	
	void simRun();
};
//FinCambiosPredador

class VisualField : NslModule
{
public:
	NslDinFloat2 worldXZ;
	NslDinFloat0 zf; NslDinFloat0 xf;
	NslDoutFloat2 visual_field;
	
private:
	
public:
	VisualField(char*,NslModule*,int,int,int);
	~VisualField() {}
	
	void simRun();
};

class DepthField : NslModule
{
public:
	NslDinFloat0 yf;
	NslDinFloat0 xf; 	
	NslDinFloat0 yw;
	NslDinFloat0 xw; 	
	NslDinFloat0 yp;
	NslDinFloat0 xp;
	NslDinFloat0 yb;	
	NslDinFloat0 xb_init;	
	NslDinFloat0 xb_end;		
	NslDoutFloat0 ps;
	NslDoutFloat0 depthY;
	NslDoutFloat0 depthX;
		
private:
	NslFloat0 safe_distance;
	NslFloat0 th;
		
public:
	DepthField(char*,NslModule*);
	~DepthField() {}
	
	void initSys();	
	void simRun();

	void updateLabel();	
	void triggerSchema();
};

class Tactile : NslModule
{
public:
	NslDinFloat0 depthY;	
	NslDinFloat0 depthX;	
	NslDoutFloat0 ps;
	
private:
	NslFloat0 safe_distance;
	NslFloat0 th;
		
public:
	Tactile(char*,NslModule*);
	~Tactile() {}
	
	void initSys();	
	void simRun();

	void updateLabel();	
	void triggerSchema();
};


class FeedMotivation : NslModule
{
public:
	NslDinFloat0 date;
	NslDinFloat0 dayhour;
	NslDinFloat0 hunger;
	NslDinFloat0 prey_ate;
	NslDoutFloat0 ps;	

private:
	int month;
	int day;
	int hour;
	int minute;
	time_t timeini; 
	NslFloat0 weigth_hunger;
	NslFloat0 weigth_date;
	NslFloat0 weigth_hour;

public:
	FeedMotivation(char*,NslModule*);

	void initSys();
	void simRun();

	void updateLabel();

};

class PreyRec : NslModule
{
public:
	NslDinFloat2 visual_field;
	NslDoutFloat2 t5_2f;
	NslDoutFloat0 ps;
	NslDinFloat0 ps_th3;
	NslDinFloat0 psm;
		
private:
	NslFloat0 th;
	NslFloat2 t5_2;	
	NslFloat0 rs_th3;
	NslFloat0 rsm;
	
public:
	PreyRec(char*,NslModule*,int,int,int);
	~PreyRec() {}

	void initSys();	
	void simRun();
	
	void updateLabel();
	void triggerSchema();
};

//CambiosPredador
class PredatorRec : NslModule
{
public:
	NslDinFloat2 visual_field;
	NslDoutFloat2 th3f;
	NslDoutFloat0 ps;
		
private:
	NslFloat0 th;
	NslFloat2 th3;		
	
public:
	PredatorRec(char*,NslModule*,int,int,int);
	~PredatorRec() {}

	void initSys();	
	void simRun();
	
	void updateLabel();
	void triggerSchema();
};
//FinCambiosPredador

class SorRec : NslModule
{
public:
	NslDinFloat2 visual_field;
	NslDoutFloat2 th10f;			// Output Data Port.
	NslDoutFloat0 ps;
	NslDinFloat0 depthY; 
	NslDinFloat0 depthX; 
				
private:
	NslFloat0 th;
	NslFloat2 th10;		
	NslFloat0 edge;		// the edge of barrier
		
public:
	SorRec(char*,NslModule*,int,int,int);
	~SorRec() {}

	void initSys();	
	void simRun();
		
	void updateLabel();
	void triggerSchema();
};

class PreyApproach : NslModule
{
public:
	NslDinFloat2 t5_2f;			// Output Data Port.
	NslDinFloat0 psfo;
	NslDoutFloat0 ps;
	NslDoutFloat1 prey_hor_f;			
				
private:	
	NslFloat1 prey_hor;			// Parcellation		(1D).
	NslFloat1 prey_hor_default;
	NslFloat2 prey_f;			// PREY ATRACTANT FIELD (2D).
	NslFloat0 prey_norm;			// Normalization
	NslFloat2 t5_2_rf;		// KERNEL for Prey Attractant Field.
	NslFloat2 t5_2_erf; 
//	NslFloat2 t5_2_irf;
//	NslFloat0 t5_2_erf_dia;
	NslFloat0 t5_2_erf_sig; 
	NslFloat0 t5_2_erf_wgt;
	NslFloat0 rsfo;
	NslFloat0 th;
	
public:
	PreyApproach(char*,NslModule*,int,int);
	~PreyApproach() {}
	
	void initSys();	
	void simRun();
		
	void updateLabel();
	void triggerSchema();
};

//CambiosPredador
class PredatorAvoid : NslModule
{
public:
	NslDinFloat2 th3f;			// Output Data Port.
	NslDinFloat0 ps_th3;
	NslDoutFloat0 ps;
	NslDoutFloat1 predator_hor_f;			
				
private:	
	NslFloat1 predator_hor;			// Parcellation		(1D).
	NslFloat1 predator_hor_default;
	NslFloat2 predator_f;			// PREY ATRACTANT FIELD (2D).
	NslFloat0 predator_norm;			// Normalization
	NslFloat2 th3_rf;		// KERNEL for Prey Attractant Field.
	NslFloat2 th3_erf; 
//	NslFloat2 t5_2_irf;
//	NslFloat0 t5_2_erf_dia;
	NslFloat0 th3_erf_sig; 
	NslFloat0 th3_erf_wgt;
	NslFloat0 rs_th3;
	NslFloat0 th;
	
public:
	PredatorAvoid(char*,NslModule*,int,int);
	~PredatorAvoid() {}
	
	void initSys();	
	void simRun();
		
	void updateLabel();
	void triggerSchema();
};
//FinCambiosPredador

class SorAvoid : NslModule
{
public:
	NslDinFloat2 th10f;			// Output Data Port.
	NslDinFloat0 psso;
	NslDoutFloat0 ps;
	NslDoutFloat1 gapsf;
					
private:
	NslFloat0 th;
	NslFloat0 rsso;
	NslFloat1 th10_hor;	// Parcellation		      (1D).
//	NslFloat1 tm_erf; 
	NslFloat1 tm_irf;
	NslFloat1 tm_rf;
//	NslFloat0 tm_erf_sig; 
	NslFloat0 tm_irf_sig;
//	NslFloat0 tm_erf_wgt; 
	NslFloat0 tm_irf_wgt;
//	NslFloat1 tm_rf_modul;	  	
	NslFloat1 gaps;			// openings within obstacles.
//	NslFloat0 gaps_norm;			// Normalization
				
public:
	SorAvoid(char*,NslModule*,int,int,int,int);
	~SorAvoid() {}

	void initSys();	
	void simRun();
		
	void updateLabel();
	void triggerSchema();
};

class BumpAvoid : NslModule
{
public:
	NslDinFloat0 depthY;	
	NslDinFloat0 depthX;	
	NslDinFloat0 psta;	
	NslDinFloat1 gaps;	
	NslDoutFloat1 gapsf;	
	NslDoutFloat0 ps;
	NslDoutFloat1 baf;				
		
private:
	NslFloat0 field_a;
	NslFloat0 field_center;
//	NslFloat1 field_side;
//	NslFloat1 last_orientation;
	NslFloat0 rsta;	
	NslFloat0 tune_tm;		// TUNE GAPS field (avoid bumping).
	NslFloat0 tune_tm_base;
	NslFloat1 tune_tm_layer;
	NslFloat0 safe_distance;
	NslFloat0 th;
		
public:
	BumpAvoid(char*,NslModule*,int);
	~BumpAvoid() {}
	
	void initSys();	
	void simRun();

	void tuningField();
	void updateLabel();	
	void triggerSchema();
};

class MHM : NslModule
{
public:
	NslDinFloat1 prey_hor_f;			
	NslDinFloat1 gapsf;
	NslDinFloat1 baf;	
	NslDinFloat0 pspa;	
	NslDinFloat0 psoa;	
	NslDoutFloat1 mhm;			// MOTOR HEADING MAP.
	NslDoutFloat0 ps;
				
    //CambiosPredador
    NslDinFloat1 predator_hor_f;			
	NslDinFloat0 psps;	
	//FinCambiosPredador

	NslDinFloat0 psm;	//HungerMotivation

private:	
	NslFloat1 mhm_hat;		// Predictive MHM.
	NslFloat1 in;
	NslFloat1 ip;			// PERCEPTUAL INTEGRATION.
//	NslFloat0 aip;
	NslFloat0 d_mhm;		// Coherence over MHM.
	NslFloat0 d_norm;
	NslFloat0 field_a;
	NslFloat0 field_center;
	NslFloat0 new_relation;	// temporary: new_relation
	NslInt0 learning;		// learning 1, otherwise 0
	NslFloat0 rspa;	
    //CambiosPredador
	NslFloat0 rsps;	
    //FinCambiosPredador
	NslFloat0 rsoa;	

	NslFloat0 rsm;
	
public:
	MHM(char*,NslModule*,int);
	~MHM() {}
	
	void initSys();	
	void simRun();

	void coherence();
	void updateLabel();	
};

class WTA : NslModule
{
public:
	NslDinFloat1 mhm;		// MOTOR HEADING MAP.
	NslDoutFloat1 wta_mhm;		// MHM after WTA.
	
public:
	WTA(char*,NslModule*,int);
	~WTA() {}
	
	void simRun();
};

class Xform : NslModule
{
public:
	NslDinFloat0 pspa;	
	//CambiosPred
    NslDinFloat0 psps;	
	//FinCambiosPred
	NslDinFloat0 psoa;	
	NslDinFloat1 wta_mhm;		
	NslDoutFloat0 ps;
	NslDinFloat0 psm;	//HungerMotivation
	NslDinFloat0 psmhm;

	NslDoutFloat0 angle;		// Heading (target) angle.
				
private:	
	NslFloat1 angle_position;
	NslFloat1 gradient;		// Gradient of weights.
	NslFloat0 rspa;	
	//CambiosPred
    NslFloat0 rsps;	
	//FinCambiosPred
	NslFloat0 rsoa;	

	NslFloat0 rsm;	
	NslFloat0 th;

public:
	Xform(char*,NslModule*,int);
	~Xform() {}
	
	void initSys();	
	void simRun();

	void updateLabel();	
//	void triggerSchema();
};

class Jump : NslModule
{
public:
	NslDinFloat0 depthY;		
	NslDinFloat0 psfo;	
	//CambiosPred
    NslDinFloat0 ps_th3;	
	//FinCambiosPred
	NslDinFloat0 psta;	
	NslDinFloat0 psdp;	
	NslDinFloat0 psmhm;	
	NslDinFloat0 psbk;	
	NslDoutFloat0 ps;
	NslDoutFloat0 out; 

	NslDinFloat0 psm;	//HungerMotivation
					
private:	
	NslFloat0 rsfo;	
	//CambiosPred
    NslFloat0 rs_th3;	
	//FinCambiosPred
	NslFloat0 rsta;	
	NslFloat0 rsdp;	
	NslFloat0 rsmhm;	
	NslFloat0 rsbk;	
	NslFloat0 th;
	NslFloat0 step;	

	NslFloat0 rsm;	
		
public:
	Jump(char*,NslModule*);
	~Jump() {}
	
	void initSys();	
	void simRun();

	void updateLabel();
	void triggerSchema();	
};

class Turn : NslModule
{
public:
	NslDinFloat0 angle;		// Heading (target) angle.
	
	NslDinFloat0 psfo;
	NslDinFloat0 ps_th3;

	NslDinFloat0 psso;	
	NslDinFloat0 psta;	
	NslDinFloat0 psba;	
	NslDinFloat0 psmhm;	
	NslDinFloat0 psm;	
	NslDinFloat0 psx;	
	NslDoutFloat0 out;	
					
private:	
	NslDoutFloat0 ps;
	NslFloat0 rsso;	
	NslFloat0 rsta;	
	NslFloat0 rsba;	
	NslFloat0 rsmhm;
	NslFloat0 rsm;
	NslFloat0 rsx;	
	
	NslFloat0 rsfo;	
	NslFloat0 rs_th3;	

	NslFloat0 th;
	float turn_angle;
	
public:
	Turn(char*,NslModule*);
	~Turn() {}
	
	void initSys();	
	void simRun();

	void updateLabel();
	void triggerSchema();	
};

class Backward : NslModule
{
public:
	NslDinFloat0 psta;	
	NslDinFloat0 psba;	
	NslDinFloat0 psfw;	
	NslDoutFloat0 ps;
	NslDoutFloat0 out; 
					
private:	
	NslFloat0 rsta;	
	NslFloat0 rsba;	
	NslFloat0 rsfw;	
	NslFloat0 th;
	NslFloat0 step;
		
public:
	Backward(char*,NslModule*);
	~Backward() {}
	
	void initSys();	
	void simRun();

	void updateLabel();
	void triggerSchema();	
};

class Frog : NslModule
{
public:
	NslDinFloat2 worldXZ;
	NslDinFloat0 xb_end; 
	NslDinFloat0 yb; 
	NslDinFloat0 zb;
	NslDinFloat0 xb_init;			 
	NslDoutFloat0 xf; 
	NslDoutFloat0 yf; 
	NslDoutFloat0 zf;
	NslDinFloat0 xw;	
	NslDinFloat0 yw; 
//	NslDinFloat0 zw;	
	//CambiosPred
	NslDinFloat0 xp;	
	NslDinFloat0 yp; 
	NslDinFloat0 zp;	
	//FinCambiosPred
	
	NslDoutFloat0 jump_step;
	NslDoutFloat0 backward_step;
	NslDoutFloat0 angle;
	NslDoutFloat0 wangle;
	
	NslDinFloat0 date;
	NslDinFloat0 dayhour;
	NslDinFloat0 hunger;	

	NslDoutFloat0 prey_ate;
	NslDinFloat0 multiprey;
private:
	VisualField visual;
	DepthField depth;
	Tactile tactile;
	FeedMotivation feedMotivation;
	PredatorRec predatorRec;	//CambiosPred	
	PreyRec preyRec;
	SorRec sorRec;	
	PreyApproach preyApproach;
	SorAvoid sorAvoid;
	PredatorAvoid predatorAvoid;	//CambiosPred	
	BumpAvoid bumpAvoid;
	MHM mhm;
	WTA wta;
	Xform xform;
	Jump jump;
	Turn turn;
	Backward backward;
			
public:
	Frog(char*,NslModule*,int,int,int,int,int,int,int);
	~Frog() {}
	
	void makeConn();
	
	void initSys();
	void endRun();//void endRun();
};

class Preypred : public NslModel
{
private:
	World world;
	Frog frog;
	Prey prey;	
	Predator predator;

public:
        Preypred();
        ~Preypred() {}
        
       void makeConn();
};

